﻿SLASH_INTERRUPTMANAGER1 = '/im'

function InterruptManager_OnLoad()
    local f = CreateFrame("Frame","IMBarAnchor")
    f:SetPoint("CENTER",nil,"CENTER")
    f:SetParent(UIParent)
    f:SetHeight(100)
    f:SetWidth(200)
    f:EnableMouse(1)
    f:SetMovable(1)
    f:SetScript("OnMouseDown",function()f:StartMoving()end)
    f:SetScript("OnMouseUp",function()f:StopMovingOrSizing()end)
    local t = f:CreateTexture()
    t:SetAllPoints(f)
    t:SetTexture(0,0,0,0.2)

    for i = 1,5 do 
        if not getglobal("IMBarIcon"..i) then
            local f = CreateFrame("Frame","IMBarIcon"..i)
            f:SetHeight(20)
            f:SetWidth(20)
            f:SetPoint("TOPLEFT","IMBarAnchor","TOPLEFT",0,(1-i)*20)
            f:SetParent(UIParent)
            local a = f:CreateTexture()
            a:SetAllPoints(f)
            a:SetTexture(0,0,0,0.4)
            local t = f:CreateFontString()
            t:SetPoint("CENTER","IMBarIcon"..i,"CENTER",0,0)
            t:SetFont("Fonts\\FRIZQT__.TTF", 16)
            t:SetText(i)
            
            local f = CreateFrame("Frame","IMBarTexture"..i)
            f:SetHeight(20)
            f:SetWidth(180)
            f:SetPoint("LEFT","IMBarIcon"..i,"RIGHT")
            f:SetParent(UIParent)
            f:SetFrameLevel(3)
            local t = f:CreateFontString("IMBarText"..i)
            t:SetPoint("LEFT",f,"LEFT",3,0)
            t:SetFont("Fonts\\FRIZQT__.TTF", 12)
            
            local f = CreateFrame("StatusBar","IMBar"..i)
            f:SetFrameStrata("MEDIUM")
            f:SetHeight(20)
            f:SetWidth(180)
            f:SetPoint("CENTER","IMBarTexture"..i,"CENTER")
            f:SetParent(UIParent)
            f:SetOrientation("HORIZONTAL")
            f:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
            f:SetMinMaxValues(0,5)
            f:SetValue(0)
            f:SetStatusBarColor(0,1,0)
            f:SetFrameLevel(2)
        end
    end
    InterruptManager:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    InterruptManager:RegisterEvent("CHAT_MSG_ADDON")
    InterruptManager:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
    InterruptManager:RegisterEvent("UNIT_SPELLCAST_START")
    InterruptManager:RegisterEvent("UNIT_DIED")
    InterruptManager:RegisterEvent("PLAYER_REGEN_DISABLED")
    InterruptManager:RegisterEvent("PLAYER_REGEN_ENABLED")
    InterruptManager:RegisterEvent("CHAT_MSG_SYSTEM")
    SendAddonMessage("InterruptM","Remind","RAID")
end

local c = CreateFrame("MessageFrame","InterruptManagerText")
c:SetWidth(300)
c:SetHeight(30)
c:SetPoint("CENTER", UIParent, "CENTER", 0, 80)
c:SetFont("Fonts\\FRIZQT__.TTF", 25)
c:SetFadeDuration(1)
c:SetTimeVisible(2)

local broadcast = "RAID"
local msgDisabled = 0
local msgDisabledT = 0
local spam = 0
local CPUSafe = GetTime()
local leader
local interrupters = {IM1,IM2,IM3,IM4,IM5}
local cooldowns1 = {}
local cooldowns2 = {}
local lastExpirant
local version = 1.16
local playStyle = 1 --[ 1=PvE, 2=PvP ]--
local PUGMode = 1
local announce = 1
local focusMode = "target"
local soloMode = 0
local registeredUsers = {}
local interruptSpells = {96231, 80964, 80965, 78675, 47528, 47476, 2139, 1766, 51680, 34490, 57994, 19647, 26090, 6552, 15487, 72}
local cooldown
local spells45 = {72}
local spells24 = {2139, 26090}
local spells20 = {34490}
local spells10 = {96231, 80964, 80965, 47528, 1766, 15487}
local spells6 = {57994}

function InterruptManager_OnEvent(self, event, ...)
    if event == "COMBAT_LOG_EVENT_UNFILTERED" then
        local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = select(1, ...)
        if type == "UNIT_DIED_HAAAAAAASD" then --[TODO!]--
            if tContains(interrupters,destName) then
                tremove(interrupters,destName)
            end
        end
        if (type == "SPELL_CAST_SUCCESS") then
            local spellID, spellName, spellSchool = select(10, ...)
            if tContains(interruptSpells, spellID) then
                if tContains(spells45,spellID) then
                    cooldown = 45
                    elseif tContains(spells24,spellID) then
                    cooldown = 24
                    elseif tContains(spells20,spellID) then
                    cooldown = 20
                    elseif tContains(spells10,spellID) then
                    cooldown = 10
                    elseif tContains(spells6,spellID) then
                    cooldown = 6
                end
                if sourceName == GetUnitName("player") then
                    if announce == 1 then
                        SendChatMessage("Used "..spellName)
                    end
                end
                if tContains(interrupters, sourceName) then
                    if #interrupters == 1 then
                        interrupters[1] = sourceName
                        IMCD(cooldown,1)
                    end
                    if #interrupters == 2 then
                        if interrupters[1] == sourceName then
                            interrupters[1] = interrupters[2]
                            IMBarTexture1:SetPoint("LEFT","IMBarIcon2","RIGHT")
                            IMBarTexture2:SetPoint("LEFT","IMBarIcon1","RIGHT")
                            IMCD(cooldown,1)
                            else
                            IMCD(cooldown,2)
                        end
                    end
                    if #interrupters == 3 then
                        if interrupters[1] == sourceName then
                            interrupters[1] = interrupters[2]
                            interrupters[2] = interrupters[3]
                            IMBarTexture1:SetPoint("LEFT","IMBarIcon3","RIGHT")
                            IMBarTexture2:SetPoint("LEFT","IMBarIcon1","RIGHT")
                            IMBarTexture3:SetPoint("LEFT","IMBarIcon2","RIGHT")
                            IMCD(cooldown,1)
                            elseif
                            interrupters[2] == sourceName then
                            interrupters[2] = interrupters[3]
                            IMBarTexture2:SetPoint("LEFT","IMBarIcon3","RIGHT")
                            IMBarTexture3:SetPoint("LEFT","IMBarIcon2","RIGHT")
                            IMCD(cooldown,2)
                            else
                            IMCD(cooldown,3)
                        end
                    end
                    if #interrupters == 4 then
                        if interrupters[1] == sourceName then
                            interrupters[1] = interrupters[2]
                            interrupters[2] = interrupters[3]
                            interrupters[3] = interrupters[4]
                            IMBarTexture1:SetPoint("LEFT","IMBarIcon4","RIGHT")
                            IMBarTexture2:SetPoint("LEFT","IMBarIcon1","RIGHT")
                            IMBarTexture3:SetPoint("LEFT","IMBarIcon2","RIGHT")
                            IMBarTexture4:SetPoint("LEFT","IMBarIcon3","RIGHT")
                            IMCD(cooldown,1)
                            elseif interrupters[2] == sourceName then
                            interrupters[2] = interrupters[3]
                            interrupters[3] = interrupters[4]
                            IMBarTexture2:SetPoint("LEFT","IMBarIcon4","RIGHT")
                            IMBarTexture3:SetPoint("LEFT","IMBarIcon2","RIGHT")
                            IMBarTexture4:SetPoint("LEFT","IMBarIcon3","RIGHT")
                            IMCD(cooldown,2)
                            elseif interrupters[3] == sourceName then
                            interrupters[3] = interrupters[4]
                            IMBarTexture3:SetPoint("LEFT","IMBarIcon4","RIGHT")
                            IMBarTexture4:SetPoint("LEFT","IMBarIcon3","RIGHT")
                            IMCD(cooldown,3)
                            else
                            IMCD(cooldown,4)
                        end
                    end
                    if #interrupters == 5 then
                        if interrupters[1] == sourceName then
                            interrupters[1] = interrupters[2]
                            interrupters[2] = interrupters[3]
                            interrupters[3] = interrupters[4]
                            interrupters[4] = interrupters[5]
                            IMBarTexture1:SetPoint("LEFT","IMBarIcon5","RIGHT")
                            IMBarTexture2:SetPoint("LEFT","IMBarIcon1","RIGHT")
                            IMBarTexture3:SetPoint("LEFT","IMBarIcon2","RIGHT")
                            IMBarTexture4:SetPoint("LEFT","IMBarIcon3","RIGHT")
                            IMBarTexture5:SetPoint("LEFT","IMBarIcon4","RIGHT")
                            IMCD(cooldown,1)
                            elseif interrupters[2] == sourceName then
                            interrupters[2] = interrupters[3]
                            interrupters[3] = interrupters[4]
                            interrupters[4] = interrupters[5]
                            IMBarTexture2:SetPoint("LEFT","IMBarIcon5","RIGHT")
                            IMBarTexture3:SetPoint("LEFT","IMBarIcon2","RIGHT")
                            IMBarTexture4:SetPoint("LEFT","IMBarIcon3","RIGHT")
                            IMBarTexture5:SetPoint("LEFT","IMBarIcon4","RIGHT")
                            IMCD(cooldown,2)
                            elseif interrupters[3] == sourceName then
                            interrupters[3] = interrupters[4]
                            interrupters[4] = interrupters[5]
                            IMBarTexture3:SetPoint("LEFT","IMBarIcon5","RIGHT")
                            IMBarTexture4:SetPoint("LEFT","IMBarIcon3","RIGHT")
                            IMBarTexture5:SetPoint("LEFT","IMBarIcon4","RIGHT")
                            IMCD(cooldown,3)
                            elseif interrupters[4] == sourceName then
                            interrupters[4] = interrupters[5]
                            IMBarTexture4:SetPoint("LEFT","IMBarIcon5","RIGHT")
                            IMBarTexture5:SetPoint("LEFT","IMBarIcon4","RIGHT")
                            IMCD(cooldown,4)
                            else
                            IMCD(cooldown,5)
                        end
                    end
                    if PUGMode == 1 and leader == UnitName("player") then
                        if GetNumRaidMembers() > 0 then
                            SendChatMessage("Interrupting next: "..interrupters[1],"SAY")
                            elseif GetNumPartyMembers() > 0 then
                            SendChatMessage("Interrupting next: "..interrupters[1],"SAY")
                        end
                    end
                    if interrupters[1] == UnitName("player") then
                        InterruptManagerText:AddMessage("You are interrupting next!",0,1,0)
                        PlaySoundFile("Sound\\Interface\\PVPFlagCapturedHordeMono.wav")
                    end
                end
            end
        end

--[Fired when leaving combat to reset the rotation]--
elseif event == "PLAYER_REGEN_ENABLED" and playStyle == 1 then
IMUpdateInterrupters()
            
--[Fired when an addon message is received]--
elseif event == "CHAT_MSG_ADDON" then
local prefix, msg,_,sender = select(1,...)
        
--[Fired when leader sets rotation to prevent everyone from spamming addon messages]--
if prefix == "InterruptM" and msg == "leader" then
IM_Leader(sender, prefix, msg)

--[Fired when someone logs on after a disconnect and issues a remind]--
elseif prefix == "InterruptM" and msg == "Remind" and sender ~= UnitName("player") then
IMRemind()

--[Fired when leader sets rotation to check version, and if everyone has the addon]--
elseif prefix == "InterruptManager" then
IM_AddonResponse(sender, prefix, msg)

--[Fired when someone closes the config window]--
elseif sender ~= UnitName("player") then
IM_SetInterrupters(sender, prefix, msg)
end

        elseif event == "UNIT_SPELLCAST_START" or event == "UNIT_SPELLCAST_CHANNEL_START" then
        local caster,_,_,_,spellID = select(1,...)
        wipe(registeredUsers)
        if caster == focusMode and (interrupters[1] == UnitName("player") or soloMode == 1) then
            local _, _, _, _, _, _, _, _, i = UnitCastingInfo(focusMode)
                if not i then
                PlaySoundFile("Sound\\Interface\\PVPFlagTakenMono.wav")
                InterruptManagerText:AddMessage("Interrupt!",0,0,1)
            end
        end
        elseif event == "PLAYER_REGEN_DISABLED" then
        if spam == 0 then
            spam = 1
            if #interrupters == #registeredUsers then
                ChatFrame1:AddMessage("All interrupters have InterruptManager enabled.",0,1,0)
                PUGMode = 0
                else
                ChatFrame1:AddMessage("Warning: Not all interrupters have InterruptManager enabled. Going PUG mode.",1,0.1,0)
                PUGMode = 1
            end
        end
        elseif event == "CHAT_MSG_SYSTEM" then
        msg = select(1,...)
    end
end

function IM_SetInterrupters(sender, prefix, msg)
    if prefix == "IM1" and msg and msg ~= "" then
        IMBarText1:SetText(msg)
        IMConfigEditbox1:SetText(msg)
        interrupters[1] = msg
        elseif prefix == "IM2" and msg and msg ~= "" then
        IMBarText2:SetText(msg)
        IMConfigEditbox2:SetText(msg)
        interrupters[2] = msg
        elseif prefix == "IM3" and msg and msg ~= "" then
        IMBarText3:SetText(msg)
        IMConfigEditbox3:SetText(msg)
        interrupters[3] = msg
        elseif prefix == "IM4" and msg and msg ~= "" then
        IMBarText4:SetText(msg)
        IMConfigEditbox4:SetText(msg)
        interrupters[4] = msg
        elseif prefix == "IM5" and msg and msg ~= "" then
        IMBarText5:SetText(msg)
        IMConfigEditbox5:SetText(msg)
        interrupters[5] = msg
    end
end

function IM_AddonResponse(sender, prefix, msg)
    if sender ~= UnitName("target") and not tContains(registeredUsers,sender) and tContains(interrupters,sender) then
        print("InterruptManager: Received addon response from "..sender)
        tinsert(registeredUsers,sender)
    end
end

function IM_Leader(sender, prefix, msg)
    leader = sender
    if broadcast == "RAID" then
        SendAddonMessage("InterruptManager",version,broadcast)
        else
        for i = 1,#interrupters do
            SendAddonMessage("InterruptManager",version,"WHISPER",interrupters[i])
        end
    end
end

function SlashCmdList.INTERRUPTMANAGER(msg, editbox)
    IMConfigFrame:Show()
end

function IMMultiModeToggle()
    if broadcast == "RAID" then
        broadcast = "WHISPER"
        IMConfigMultiToggleButton:SetText("Disable Multi-Mode")
        ChatFrame1:AddMessage("Multi-Target enabled. You can now set up several rotations without them interfering with eachother.",1,0.5,0)
        else
        ChatFrame1:AddMessage("Multi-Target disabled.",1,0.5,0)
        IMConfigMultiToggleButton:SetText("Enable Multi-Mode")
        broadcast = "RAID"
    end
end

function IMAnnounceToggle()
    if announce == 1 then
        announce = 0
        IMConfigAnnounceToggleButton:SetText("Enable Announce")
        ChatFrame1:AddMessage("InterruptManager: Announce is now disabled.",1,0.5,0)
    else
        announce = 1
        IMConfigAnnounceToggleButton:SetText("Disable Announce")
        ChatFrame1:AddMessage("InterruptManager: Announce is now enabled.",1,0.5,0)
    end
end

function IMFocusModeToggle()
    if focusMode == "target" then
        focusMode = "focus"
        IMConfigFocusToggleButton:SetText("Disable Focus Mode")
        ChatFrame1:AddMessage("InterruptManager: Focus mode is now enabled. Will now only warn when your focus is casting a spell.",1,0.5,0)
        else
        focusMode = "target"
        IMConfigFocusToggleButton:SetText("Enable Focus Mode")
        ChatFrame1:AddMessage("InterruptManager: Focus mode is now disabled.",1,0.5,0)
    end
end

function IMSoloModeToggle()
    if soloMode == 0 then
        soloMode = 1
        IMConfigSoloToggleButton:SetText("Disable Solo Mode")
        ChatFrame1:AddMessage("InterruptManager: Solo mode is now enabled. Will now warn if a spell is being cast by your target/focus regardless of your position in the queue.",1,0.5,0)
        else
        soloMode = 0
        IMConfigSoloToggleButton:SetText("Enable Solo Mode")
        ChatFrame1:AddMessage("InterruptManager: Solo mode is now disabled.",1,0.5,0)
    end
end

function IMRemind()
    if leader == UnitName("player") then
        SendAddonMessage("IM1",interrupters[1],broadcast)
        SendAddonMessage("IM2",interrupters[2],broadcast)
        SendAddonMessage("IM3",interrupters[3],broadcast)
        SendAddonMessage("IM4",interrupters[4],broadcast)
        SendAddonMessage("IM5",interrupters[5],broadcast)
    end
end

function IMUpdateInterrupters()
    for i=1,5 do
        if getglobal("IMConfigEditbox"..i):GetText() ~= "" and not strfind(getglobal("IMConfigEditbox"..i):GetText()," interrupter") then
            interrupters[i] = getglobal("IMConfigEditbox"..i):GetText()
        end
    end
    for i = 1,5 do
        getglobal("IMBarText"..i):SetText("")
        getglobal("IMBarText"..i):SetText(interrupters[i])
    end
    for i=1,5 do
        getglobal("IMBarTexture"..i):SetPoint("LEFT","IMBarIcon"..i,"RIGHT")
    end
end

function IMOnConfigClose()
    ChatFrame1:UnregisterEvent("CHAT_MSG_SYSTEM")
    IMCD(2,1)
    msgDisabled = 1
    wipe(interrupters)
    for i=1,5 do
        getglobal("IMBarText"..i):SetText("")
    end
    IMUpdateInterrupters()
    if broadcast == "RAID" then
        SendAddonMessage("InterruptM","leader",broadcast)
        SendAddonMessage("IM1",interrupters[1],broadcast)
        SendAddonMessage("IM2",interrupters[2],broadcast)
        SendAddonMessage("IM3",interrupters[3],broadcast)
        SendAddonMessage("IM4",interrupters[4],broadcast)
        SendAddonMessage("IM5",interrupters[5],broadcast)
        else
        for i=1,#interrupters do
            SendAddonMessage("InterruptM","leader","WHISPER",interrupters[i])
            SendAddonMessage("IM1",interrupters[1],"WHISPER",interrupters[i])
            SendAddonMessage("IM2",interrupters[2],"WHISPER",interrupters[i])
            SendAddonMessage("IM3",interrupters[3],"WHISPER",interrupters[i])
            SendAddonMessage("IM4",interrupters[4],"WHISPER",interrupters[i])
            SendAddonMessage("IM5",interrupters[5],"WHISPER",interrupters[i])
        end
    end
    spam = 0
end

function InterruptManager_InterrupterDied(destName)
    tremove(interrupters,destName)
    for i = 1,#interrupters do
        local j
        if interrupters[i] == destName then
            if interrupters[j] then
                interrupters[i] = interrupters[j]
            end
        end
    end
end

function InterruptManager_OnUpdate(self, elapsed)
    for i=1,#interrupters do
        if cooldowns1[i] and cooldowns2[i] then
            getglobal("IMBar"..i):SetValue(cooldowns1[i] + cooldowns2[i] - GetTime())
            getglobal("IMBar"..i):SetStatusBarColor((cooldowns1[i] - GetTime()) / cooldowns2[i] + 1,1,0)
        end
    end
    if GetTime() >= CPUSafe then
        CPUSafe = GetTime() + 0.5
        if GetTime() >= lastExpirant then
            InterruptManager:SetScript("OnUpdate",nil)
            else
        end
        if msgDisabled == 1 then
            if msgDisabledT == 3 then
                ChatFrame1:RegisterEvent("CHAT_MSG_SYSTEM")
                msgDisabledT = 0
                msgDisabled = 0
                else
                msgDisabledT = msgDisabledT + 1
            end
        end
    end
end

function IMCD(duration, num)
    cooldowns1[num] = GetTime()
    cooldowns2[num] = duration
    getglobal("IMBar"..num):SetMinMaxValues(0,duration)
    if not lastExpirant or cooldowns1[num] + cooldowns2[num] > lastExpirant then
        lastExpirant = cooldowns1[num] + cooldowns2[num]
    end
    InterruptManager:SetScript("OnUpdate",InterruptManager_OnUpdate)
end

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end